/* Generated By:JavaCC: Do not edit this line. ConfigFileParser.java */
package simulator;

import java.util.Vector;
import java.util.Hashtable;
import simulator.locale.*;
import simulator.*;
import utilities.TaemsRandom;
import utilities.Log;
import utilities.ImageComponent;
import utilities.Graph;
import utilities.LoadClass;
import utilities.ContainerNodePanel;
import utilities.NodePanel;
import java.awt.*;
import java.net.*;
import javax.swing.*;

class InternalParseException extends Exception
{
    InternalParseException() { super(); }
    InternalParseException(String s) { super(s); }
};

public class ConfigFileParser implements ConfigFileParserConstants {

  static final public Simulator Input() throws ParseException {
  Token t, t2, t3, t4, t5, t6, t7, t8, t9, t10;
  EventQueue queue = EventQueue.getQueue();
  String logfile = null;
  int loglevel = 0;
  boolean flush = false;
  String filename;
  int start, end, tbts, count;
  int mean, stddev;
  int nd_index = 0;
  long seed = System.currentTimeMillis();
  double prob, probsum;
  Vector grammarvec = new Vector();
  Vector nondet = new Vector();
  Vector tempvec;
  TaemsRandom rand = null;
  Log logger = null;
  Simulator sim;
  Linkage link;
  Locale loc;
  int []xpoints;
  int []ypoints;
  int npoints;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEED:
      case LOGFILE:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEED:
        jj_consume_token(SEED);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case NUM:
          t = jj_consume_token(NUM);
                  seed = Long.valueOf(t.image).longValue();
          break;
        case TIME:
          jj_consume_token(TIME);
                   seed = System.currentTimeMillis();
          break;
        default:
          jj_la1[1] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      case LOGFILE:
        jj_consume_token(LOGFILE);
        t = jj_consume_token(ID);
                    logfile = t.image;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LEVEL:
          jj_consume_token(LEVEL);
          t = jj_consume_token(NUM);
                           loglevel = Integer.valueOf(t.image).intValue();
          break;
        default:
          jj_la1[2] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[3] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FLUSH:
      jj_consume_token(FLUSH);
                   flush = true;
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
           System.err.println("Creating log: "+logfile);
           try {
             if ((logfile == null) || (logfile.equals("System.err"))) {
               logfile = new String("Standart error");
               logger = new Log(System.err);
             }
             else
               logger = new Log(logfile);
           } catch (Exception e) {System.err.println("Could not open Log file");}
           logger.setLevel(loglevel);
           logger.setFlush(flush);
           if (logger != null)
             Log.setDefault(logger);

           logger.log("Creating TaemsRandom");
           rand = new TaemsRandom(seed);
           TaemsRandom.setDefault(rand);
           sim = new Simulator();
           sim.simulator = sim;
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TIMEOUT:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_2;
      }
      jj_consume_token(TIMEOUT);
      t = jj_consume_token(NUM);
                      sim.setTimeout(Integer.valueOf(t.image).intValue());
    }
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LOCATIONMAPPING:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_3;
      }
      jj_consume_token(LOCATIONMAPPING);
      t = jj_consume_token(ID);
                             sim.setLocationMapping(t.image);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case GRAPH:
      jj_consume_token(GRAPH);
      t = jj_consume_token(ID);
      t2 = jj_consume_token(ID);
          Object a[] = new Object [1];
          a[0] = t2.image;
          Object o = LoadClass.load(t.image, a);
          if (o == null || !(o instanceof Graph))
          {
              System.err.println("invalid graph specified, defaulting to utilities.Graph");
              o = new Graph();
          }
          sim.setGraph((Graph) o);
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LOCALE:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_4;
      }
      jj_consume_token(LOCALE);
      t = jj_consume_token(ID);
      t2 = jj_consume_token(ID);
      t3 = jj_consume_token(ID);
          xpoints = new int[10];
          ypoints = new int[10];
          loc = sim.addLocale(t.image, t2.image, t3.image);
          NodePanel pan = (NodePanel)
                  sim.getGraph().getLayers().getPanel("default", loc);
          npoints = 0;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMAGE:
        jj_consume_token(IMAGE);
        t7 = jj_consume_token(ID);
          try {
              pan.setBackImage(new ImageComponent(new URL(t7.image)));
          } catch (MalformedURLException e) {
              System.err.println("Unable to load image " + t7.image);
          }
        break;
      default:
        jj_la1[9] = jj_gen;
        ;
      }
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LINKLOCATION:
          ;
          break;
        default:
          jj_la1[10] = jj_gen;
          break label_5;
        }
        jj_consume_token(LINKLOCATION);
        t8 = jj_consume_token(ID);
        t9 = jj_consume_token(NUM);
        t10 = jj_consume_token(NUM);
          Point linkloc = new Point(Integer.valueOf(t9.image).intValue(), Integer.valueOf(t10.image).intValue());
          ((ContainerNodePanel)pan).setLinkLocation(t8.image, linkloc);
      }
      label_6:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case NUM:
          ;
          break;
        default:
          jj_la1[11] = jj_gen;
          break label_6;
        }
        t5 = jj_consume_token(NUM);
        t6 = jj_consume_token(NUM);
          xpoints[npoints] = Integer.valueOf(t5.image).intValue();
          ypoints[npoints++] = Integer.valueOf(t6.image).intValue();
          if (npoints == 2)
          {
              Rectangle shape = new Rectangle(xpoints[0], ypoints[0], xpoints[1] - xpoints[0], ypoints[1] - ypoints[0]);
              pan.setShape(shape);
          }
      }
    }
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LINKAGE:
        ;
        break;
      default:
        jj_la1[12] = jj_gen;
        break label_7;
      }
      jj_consume_token(LINKAGE);
      t = jj_consume_token(ID);
      t2 = jj_consume_token(ID);
      t3 = jj_consume_token(ID);
      t4 = jj_consume_token(ID);
                  link = sim.addLinkage(t.image, t2.image, t3.image, t4.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NUM:
        t5 = jj_consume_token(NUM);
        t6 = jj_consume_token(NUM);
          int x = Integer.valueOf(t5.image).intValue();
          int y = Integer.valueOf(t6.image).intValue();
          //link.getEdge().setLocation(new Point(x, y));
          //link.getEdge().setMoveable(false);

        break;
      default:
        jj_la1[13] = jj_gen;
        ;
      }
    }
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RESOURCE:
        ;
        break;
      default:
        jj_la1[14] = jj_gen;
        break label_8;
      }
      jj_consume_token(RESOURCE);
      t6 = jj_consume_token(ID);
      t = jj_consume_token(ID);
      t2 = jj_consume_token(NUM);
      t3 = jj_consume_token(NUM);
      t4 = jj_consume_token(NUM);
      t5 = jj_consume_token(ID);
           sim.addResource(t6.image, t.image,
                new Resources(t.image,
                     Float.valueOf(t2.image).floatValue(),
                     Float.valueOf(t3.image).floatValue(),
                     Float.valueOf(t4.image).floatValue(),
                     t5.image));
    }
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONSUMABLE:
        ;
        break;
      default:
        jj_la1[15] = jj_gen;
        break label_9;
      }
      jj_consume_token(CONSUMABLE);
      t6 = jj_consume_token(ID);
      t = jj_consume_token(ID);
      t2 = jj_consume_token(NUM);
      t3 = jj_consume_token(NUM);
      t4 = jj_consume_token(NUM);
      t5 = jj_consume_token(ID);
           sim.addResource(t6.image, t.image,
                new ConsumableResources(t.image,
                     Float.valueOf(t2.image).floatValue(),
                     Float.valueOf(t3.image).floatValue(),
                     Float.valueOf(t4.image).floatValue(),
                     t5.image));
    }
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SCRIPTS:
        ;
        break;
      default:
        jj_la1[16] = jj_gen;
        break label_10;
      }
      jj_consume_token(SCRIPTS);
      t = jj_consume_token(ID);
          Scripter.addSource(t.image);
    }
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SENSORS:
        ;
        break;
      default:
        jj_la1[17] = jj_gen;
        break label_11;
      }
      jj_consume_token(SENSORS);
      t = jj_consume_token(ID);
          sim.configureSensingModule(t.image);
    }
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case QUALITYFACTOR:
        ;
        break;
      default:
        jj_la1[18] = jj_gen;
        break label_12;
      }
      jj_consume_token(QUALITYFACTOR);
      t = jj_consume_token(ID);
          sim.setComplexNLE(true) ;
    }
    jj_consume_token(PORT);
    t = jj_consume_token(NUM);
          sim.setPort(Integer.valueOf(t.image).intValue());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AUTOSTART:
      jj_consume_token(AUTOSTART);
      t = jj_consume_token(NUM);
        sim.setAutoStart(true, Integer.parseInt(t.image));
      break;
    default:
      jj_la1[19] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TEXTINTERFACE:
      jj_consume_token(TEXTINTERFACE);
      t = jj_consume_token(ID);
        sim.setTextInter(true);
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    jj_consume_token(BACKGROUND);
    t = jj_consume_token(ID);
          Display.getDisplay().setBackground(t.image);
        {if (true) return sim;}
    throw new Error("Missing return statement in function");
  }

  static private boolean jj_initialized_once = false;
  static public ConfigFileParserTokenManager token_source;
  static SimpleCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[21];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x280,0x100,0x8000,0x280,0x10000,0x10000000,0x0,0x0,0x40000000,0x0,0x0,0x0,0x0,0x0,0x200000,0x400000,0x800000,0x1000000,0x2000000,0x0,0x0,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x0,0x200,0x0,0x0,0x0,0x0,0x4,0x20,0x0,0x8,0x10,0x200,0x1,0x200,0x0,0x0,0x0,0x0,0x0,0x40,0x80,};
   }

  public ConfigFileParser(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ConfigFileParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  public ConfigFileParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ConfigFileParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  public ConfigFileParser(ConfigFileParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  public void ReInit(ConfigFileParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;

  static public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[43];
    for (int i = 0; i < 43; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 21; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 43; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

}
