/* Copyright (C) 2005, University of Massachusetts, Multi-Agent Systems Lab
 * See LICENSE for license information
 */

/***************************************************************************************
 *	StopSim.java
 ***************************************************************************************/

package simulator.script;

import simulator.*;

/**
 * Stop the simulator
 * <P>
 * <B>Data</B><BR>
 * <UL>
 * <LI>None
 * </UL>
 */
public class StopSim extends Reaction {

  /**
   * Constructor.
   */
  public StopSim(String d) {
    super(d);
  }
  
  /**
   * Starts the reaction
   * @return True if it was sucessfull, false otherwise
   */
  public boolean realize() {
     Simulator.getSimulator().setRunning(false);
     return true;
  }
}
