/* Copyright (C) 2005, University of Massachusetts, Multi-Agent Systems Lab
 * See LICENSE for license information
 */

/*****************************************************************
 * $Source: /nfs/shelob/cvs/masl/Mass/modules/simulator/simulator/sensor/LinkageSensor.java,v $
 * $Revision: 1.2 $
 ******************************************************************
 *
 *                   LinkageSensor.java
 *
 *     Author : Peter Amstutz [amstutz@cs.umass.edu]
 *              
 *
 * Creation date: 29 June 99 12:43
 * Last file update: $Date: 2005/01/19 19:00:21 $
 *****************************************************************/

package simulator.sensor;

import simulator.locale.*;
import java.util.Enumeration;

/** 
 * <B>Module</B>: simulator.sensor<p>
 * <B>Copyright</B>: UMASS - MASL 1999<P>
 * @version $Revision: 1.2 $
 * @author  Peter Amstutz (amstutz@cs.umass.edu)<P>
 * <B> Description:</B>
 *
 * Sensor type which agents can use to query what sublocales
 * are in their current locale.
 */
public class LinkageSensor extends Sensor {
	/**
	   Constructor.
	   @param <b>n</b> The sensor name
	   @param <b>d</b> The sensor data line (from sensors.cfg)
	 */
	public LinkageSensor(String n, String d) {
		super(n, d);
	}

	public Object getObjectSensed(simulator.locale.Locale loc) {
		return loc;
	}

	/** 
		@param <b>l</b> The locale we're sensing from
		@param <b>d</b> A dataline (unused)
		@return A space-delimited list of locales
	 */
	public Object sense(Locale l, String d) {
		String s="";
		Enumeration e = l.getLinkages();
		while(e.hasMoreElements()) {
			Linkage i = ((Linkage)e.nextElement());
			s = s + "(" + i.getName() + ",";
			Enumeration n = i.otherSide(l);
			while(n.hasMoreElements()) {
				Locale o = ((Locale)n.nextElement());
				s = s + o.getName();
				if(n.hasMoreElements()) s = s + ",";
			}
			s = s + ")";
			if(e.hasMoreElements()) s = s + " ";
		}
		return s;
	}
}
