/* Copyright (C) 2005, University of Massachusetts, Multi-Agent Systems Lab
 * See LICENSE for license information
 */

/*****************************************************************
 * $Source: /nfs/shelob/cvs/masl/Mass/modules/simulator/simulator/sensor/ParentLocaleSensor.java,v $
 * $Revision: 1.2 $
 ******************************************************************
 *
 *                   ParentLocaleSensor.java
 *
 *     Author : Peter Amstutz [amstutz@cs.umass.edu]
 *              
 *
 * Creation date: 29 June 99 12:43
 * Last file update: $Date: 2005/01/19 19:00:22 $
 *****************************************************************/

package simulator.sensor;

import simulator.locale.*;

/** 
 * <B>Module</B>: simulator.sensor<p>
 * <B>Copyright</B>: UMASS - MASL 1999<P>
 * @version $Revision: 1.2 $
 * @author  Peter Amstutz (amstutz@cs.umass.edu)<P>
 * <B> Description:</B>
 *
 * Sensor type which agents can use to query their current locale.
 */
public class ParentLocaleSensor extends Sensor {
	/**
	   Constructor.
	   @param <b>n</b> The sensor name
	   @param <b>d</b> The sensor data line (from sensors.cfg)
	 */
	public ParentLocaleSensor(String n, String d) {
		super(n, d);
	}
    public Object getObjectSensed(simulator.locale.Locale loc) {
		return loc.getParent();
	}
	/** 
		@param <b>l</b> The locale we're sensing from
		@param <b>d</b> A dataline (unused)
		@return A string with the locale's name.
	 */
	public Object sense(Locale l, String d) {
		if(l.getParent()!=null)
			return l.getParent().getName();
		else return "null";
	}
}
